## devicexlib 0.1.0

=== Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
MAKE=make

#
# manual
#
default: 
	@echo 
	@echo  "  *** deviceXlib *** "
	@echo 
	@echo  "  to configure, type:  ./configure [<options>]"
	@echo  "  to compile,   type:  make <target>"
	@echo 
	@echo  "  Possible <target>'s are: "
	@echo 
	@echo  "     all                builds the library"
	@echo  "     test               all the executables testing the library"
	@echo  "     deps               update fortran90 dependencies"
	@echo  "     gen                generate Fortran sources"
	@echo  "     clean              remove executables and objects"
	@echo  "     clean_test         clean up the test examples"
	@echo  "     distclean          revert distribution to the original status"
	@echo 

#
# MAIN target
#
all: libsrc

deps:
	if test -x ./config/makedeps.sh ; then ./config/makedeps.sh ; fi
gen:
	if test -d src_generator ; then ( cd src_generator ; $(MAKE) ) ; fi

# 
# LIBS and MODULES
#
libextlibs: 
	if test -d extlibs ; then \
	( cd extlibs ; $(MAKE) ) ; fi

libsrc:
	if test -d src/ ; then \
	( cd src/ ; $(MAKE) ) ; fi

test: libextlibs libsrc
	if test -d src/ ; then \
	( cd src/ ; $(MAKE) test ) ; fi

#
# CLEAN UP
#
clean:
	if test -d extlibs ;   then ( cd extlibs;   $(MAKE) clean ) ; fi
	if test -d src ;       then ( cd src;       $(MAKE) clean ) ; fi
	- /bin/rm -rf *.dat *.mod
	- /bin/rm -rf ./bin/*x

distclean: clean
	if test -d extlibs ;   then ( cd extlibs;   $(MAKE) distclean ) ; fi
	- /bin/rm -rf make.inc config.log ./config/configure.msg \
		./config/config.log ./config/config.status \
		./config/*.lineno \
		./include/configure.h ./include/fft_defs.h \
	        ./include/c_defs.h    ./include/f_defs.h\
		*/dum1 */dum2

=== extlibs/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc


#
# MAIN target
#
all: libblas liblapack

#
# blas
#
libblas:  libblas_$(BLAS_LIBS_SWITCH)

libblas_internal:
	 if test -d blas ;    then ( cd blas;    $(MAKE) ) ; fi

libblas_external:
libblas_:


#
# lapack
#
liblapack:  liblapack_$(LAPACK_LIBS_SWITCH)

liblapack_internal:
	 if test -d lapack ;  then ( cd lapack;  $(MAKE) ) ; fi

liblapack_external:
liblapack_:


#
# cleaning
#
clean distclean:
	 if test -d blas ;    then ( cd blas;    $(MAKE) $@ ) ; fi
	 if test -d lapack ;  then ( cd lapack;  $(MAKE) $@ ) ; fi

=== src/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc

DIR=src
LIBOBJS_LOC= $(LIBOBJS)

OBJS= \
deviceXlib_mod.o \
device_memcpy.o \
device_memcpy_mod.o \
device_auxfunc.o \
device_auxfunc_mod.o \
device_fbuff.o \
device_fbuff_mod.o \
timer.o \
timer_mod.o

#
# main targets
#
all: libdevXlib.a

test: test_memcpy.x test_memcpy_async.x test_fbuff.x

fortcuda:
	$(MAKE) -C FortCuda


test_memcpy.x: test_memcpy.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_memcpy.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_memcpy_async.x: test_memcpy_async.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_memcpy_async.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_fbuff.x: tester.o test_fbuff.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ tester.o test_fbuff.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

libdevXlib.a : $(OBJS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

# clean
clean:
	 - /bin/rm -rf *.o *.a *core *.F90 work.pc work.pcl *.mod *.x
	 - cd FortCuda && /bin/rm -rf *.o *.a *core work.pc work.pcl *.mod *.x
distclean:   clean


# dependencies
include make.depend

=== src_generator/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc

DIR=src_gener

#
# main targets
#
all: memcpy auxfunc fbuff

memcpy auxfunc fbuff:
	if [ -x generate_$@.py ] ; then ./generate_$@.py ; \
	   mv *.f90 *.F ../src ; fi

# clean
clean:
	 - /bin/rm -rf *.f90 *.F __*__ 
distclean:   clean


# dependencies
include make.depend

=== src/FortCuda/Makefile ===
##
## Makefile
##  
## Made by David Car, modified by Pietro Bonfa'
##
## Started on  Sat Oct 17 16:17:38 2009 David Car
## Last update Sat Oct 17 16:17:38 2009 David Car
## 
include ../../make.inc

.SUFFIXES: .F90 .o

MOD_DIR=.
LIB_DIR=.

DEPENDENCIES=Make.depend

#FC ?= gfortran
FFLAGS += $(FFLAGS_LINELEN)
INCDIR ?= /usr/local/cuda/include

OUTPUT_CUDA=$(LIB_DIR)/libFortCUDA.a
OUTPUT_OPENCL=$(LIB_DIR)/libFortCL.a
OUTPUT_GPU=$(LIB_DIR)/libFortGPU.a
default: strip_comments $(OUTPUT_CUDA) restore_comments
all: $(OUTPUT_CUDA) $(OUTPUT_OPENCL) $(OUTPUT_GPU)
########################################################################
##
## PRIMARY TARGETS
##
########################################################################
$(OUTPUT_CUDA): CUDA.o
	$(AR) -rs $@ $^
$(OUTPUT_OPENCL): OpenCL.o
	$(AR) -rs $@ $^
$(OUTPUT_GPU): CUDA.o OpenCL.o
	$(AR) -rs $@ $^

autoparse:
	python FortCUDA_File_Parser.py -E --log-file=log -m --save-pp \
		-I/usr/local/cuda/include

strip_comments:
	tar -cf .fortranfiles.tar *.F90
	sed -i 's:!.*$$::g' *.F90

restore_comments:
	tar -xf .fortranfiles.tar


########################################################################
##
## IMPLICIT RULES
##
########################################################################
.f90.o:
	$(MPIF90) $(COMPATIBILITY) -c $(FFLAGS) -I$(MOD_DIR) $<
.F90.o:
	$(MPIF90) $(COMPATIBILITY) -c $(FFLAGS) -I$(MOD_DIR) $<

########################################################################
##
## CLEANING TARGETS
##
########################################################################
clean:
	-rm *.o *.mod
cleaner: clean
cleanest: cleaner

-include $(DEPENDENCIES)

=== debian/changelog ===
devicexlib (0.1.0-2) unstable; urgency=medium

  * debian/rules, debian/libdevicexlib-dev.install: Install Fortran90 modules
    into /usr/include.

 -- Michael Banck <mbanck@debian.org>  Thu, 10 Nov 2022 21:16:20 +0100

devicexlib (0.1.0-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Fri, 31 Dec 2021 01:35:59 +0100

=== debian/control ===
Source: devicexlib
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>> 12~),
               gfortran,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.4.1
Homepage: https://gitlab.com/max-centre/components/devicexlib
Vcs-Browser: https://salsa.debian.org/debichem-team/devicexlib
Vcs-Git: https://salsa.debian.org/debichem-team/devicexlib.git

Package: libdevicexlib-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library wrapping device-oriented routines and utilities
 The deviceXlib library wraps device-oriented routines and utilities.
 .
 This package contains the static library.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/buildflags.mk
LDFLAGS += -Wl,--as-needed
CFLAGS += $(LDFLAGS)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	./configure

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}
	mkdir -p $(CURDIR)/debian/tmp/usr/include
	install $(CURDIR)/src/libdevXlib.a $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}
	install $(CURDIR)/src/*.mod $(CURDIR)/debian/tmp/usr/include

override_dh_auto_test:
	dh_auto_test
	(cd bin; for TEST in test*; do ./$$TEST; if [ "$$?" != 0 ]; then exit 1; fi; done)

## devicexlib 0.8.2

=== debian/changelog ===
devicexlib (0.8.2-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Fri, 29 Dec 2023 17:00:23 +0100

devicexlib (0.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Dec 2023 18:27:47 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: Library wrapping device-oriented routines and utilities
  The deviceXlib library wraps device-oriented routines and utilities.
  .

## devicexlib 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21 FATAL_ERROR)

project(devXlib
    VERSION 0.2
    DESCRIPTION "Library wrapping device-oriented routines and utilities"
    LANGUAGES Fortran C)

###########################################################
# Options
###########################################################
set(DEVXLIB_ENABLE_ACC "CUDAF" CACHE STRING "Enable a specific acceleration")
set_property(CACHE DEVXLIB_ENABLE_ACC PROPERTY STRINGS "CUDAF" "OPENACC" "OPENMPGPU")

set(DEVXLIB_ENABLE_GPU_BLAS "CUBLAS" CACHE STRING "Enable a specific BLAS offload")
set_property(CACHE DEVXLIB_ENABLE_GPU_BLAS PROPERTY STRINGS "CUBLAS" "MKLGPU" "ROCBLAS")

###########################################################
# Dependencies
###########################################################
# Option dependencies
get_property(OPT_STRINGS CACHE DEVXLIB_ENABLE_ACC PROPERTY STRINGS)
if(NOT DEVXLIB_ENABLE_ACC IN_LIST OPT_STRINGS)
    message(FATAL_ERROR "Wrong value of the parameter 'DEVXLIB_ENABLE_ACC'")
endif()

get_property(OPT_STRINGS CACHE DEVXLIB_ENABLE_GPU_BLAS PROPERTY STRINGS)
if(NOT DEVXLIB_ENABLE_GPU_BLAS IN_LIST OPT_STRINGS)
    message(FATAL_ERROR "Wrong value of the parameter 'DEVXLIB_ENABLE_GPU_BLAS'")
endif()

# Compiler dependencies
if(DEVXLIB_ENABLE_ACC STREQUAL "CUDAF")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "NVHPC" OR CMAKE_Fortran_COMPILER_ID STREQUAL "PGI"))
	    message(FATAL_ERROR "CUDA Fortran is supported only from the Nvidia Fortran compiler")
    endif()
elseif(DEVXLIB_ENABLE_ACC STREQUAL "OPENACC")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "NVHPC" OR CMAKE_Fortran_COMPILER_ID STREQUAL "PGI" OR CMAKE_Fortran_COMPILER_ID STREQUAL "GNU"))
        message(FATAL_ERROR "OPENACC is supported only from Nvidia and GNU Fortran compilers")
    endif()
elseif(DEVXLIB_ENABLE_ACC STREQUAL "OPENMPGPU")
    if(NOT CMAKE_Fortran_COMPILER_ID STREQUAL "IntelLLVM")
        message(FATAL_ERROR "OpenMP GPU offload is supported only from the Intel OneAPI compiler")
    endif()
endif()

# BLAS offload dependencies
if(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "CUBLAS")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "NVHPC" OR CMAKE_Fortran_COMPILER_ID STREQUAL "PGI" OR CMAKE_Fortran_COMPILER_ID STREQUAL "GNU"))
        message(FATAL_ERROR "Nvidia CUBLAS is supported only from Nvidia and GNU Fortran compilers")
    endif()
elseif(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "MKLGPU")
    if(NOT CMAKE_Fortran_COMPILER_ID STREQUAL "IntelLLVM")
        message(FATAL_ERROR "Intel MKLGPU BLAS is supported only from Intel OneAPI compiler")
    endif()
endif()

###########################################################
# Build Type
###########################################################
set(default_build_type "RelWithDebInfo")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}"
        CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE
        PROPERTY
            STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

###########################################################
# Build helpers
###########################################################
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if (NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_Fortran_MODULE_DIRECTORY "${CMAKE_INSTALL_PREFIX}/mod")
endif()

############################################################
# Compiler vendor specific options and bug checks
############################################################
if(CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
    include(NVFortranCompiler)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    include(GNUFortranCompiler)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "IntelLLVM")
    include(IntelOneAPIFortranCompiler)
endif()

###########################################################
# OpenACC
###########################################################
if(DEVXLIB_ENABLE_ACC STREQUAL "OPENACC")
    find_package(OpenACC REQUIRED)
endif()

###########################################################
# OpenMP
###########################################################
find_package(OpenMP REQUIRED)

###########################################################
# BLAS offloading
###########################################################
if(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "CUBLAS")
    find_package(CUDAToolkit REQUIRED)
elseif(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "MKLGPU")
    find_package(MKL CONFIG REQUIRED)
elseif(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "ROCBLAS")
    find_package(rocblas REQUIRED)
endif()

###########################################################
# LAPACK
###########################################################
find_package(LAPACK REQUIRED)

###########################################################
# Add directories
###########################################################
add_subdirectory(src)

=== INSTALL/Makefile ===
include ../make.inc

.SUFFIXES : .o .f 
all:  testlsame testslamch testdlamch testsecond testdsecnd testieee testversion 

testlsame:  lsame.o lsametst.o
	$(LOADER) $(LOADOPTS) -o testlsame lsame.o lsametst.o

testslamch: slamch.o lsame.o slamchtst.o
	$(LOADER) $(LOADOPTS) -o testslamch slamch.o lsame.o slamchtst.o

testdlamch: dlamch.o lsame.o dlamchtst.o
	$(LOADER) $(LOADOPTS) -o testdlamch dlamch.o lsame.o dlamchtst.o

testsecond: second_$(TIMER).o secondtst.o
	@echo "[INFO] : TIMER value: $(TIMER) (given by make.inc)"
	$(LOADER) $(LOADOPTS) -o testsecond second_$(TIMER).o secondtst.o

testdsecnd: dsecnd_$(TIMER).o dsecndtst.o
	@echo "[INFO] : TIMER value: $(TIMER) (given by make.inc)"
	$(LOADER) $(LOADOPTS) -o testdsecnd dsecnd_$(TIMER).o dsecndtst.o

testieee: tstiee.o
	$(LOADER) $(LOADOPTS) -o testieee tstiee.o

testversion: ilaver.o LAPACK_version.o
	    $(LOADER) $(LOADOPTS) -o testversion ilaver.o LAPACK_version.o

clean:
	rm -f *.o

slamch.o: slamch.f ; $(FORTRAN) $(NOOPT) -c $< -o $@
dlamch.o: dlamch.f ; $(FORTRAN) $(NOOPT) -c $< -o $@

.f.o: ; $(FORTRAN) $(OPTS) -c $< -o $@

=== extlibs/Makefile ===
--- 
+++ 
@@ -4,7 +4,6 @@
 #===============================
 #
 -include ../make.inc
-
 
 #
 # MAIN target
@@ -22,7 +21,6 @@
 libblas_external:
 libblas_:
 
-
 #
 # lapack
 #
@@ -34,11 +32,8 @@
 liblapack_external:
 liblapack_:
 
+clean:
+	 if test -d blas ;         then ( cd blas;     $(MAKE) $@ ) ; fi
+	 if test -d lapack ;       then ( cd lapack;   $(MAKE) $@ ) ; fi
 
-#
-# cleaning
-#
-clean distclean:
-	 if test -d blas ;    then ( cd blas;    $(MAKE) $@ ) ; fi
-	 if test -d lapack ;  then ( cd lapack;  $(MAKE) $@ ) ; fi
-
+distclean: clean

=== src/CMakeLists.txt ===
set(SRC_F_devXlib
    # Linalg
    devxlib_linalg.f90
    devxlib_linalg_axpy.f90
    devxlib_linalg_dot.f90
    devxlib_linalg_gemm.f90
    devxlib_linalg_gemv.f90
    # Malloc
    devxlib_malloc.f90
    devxlib_malloc_alloc.f90
    devxlib_malloc_free.f90
    devxlib_malloc_allocated.f90
    # Mapping
    devxlib_mapping.f90
    devxlib_mapping_map.f90
    devxlib_mapping_unmap.f90
    devxlib_mapping_mapped.f90
    # Memcpy
    devxlib_memcpy.f90
    devxlib_memcpy_d2d.f90
    devxlib_memcpy_d2h.f90
    devxlib_memcpy_h2d.f90
    devxlib_memcpy_h2h.f90
    # Auxfunc
    devxlib_auxfunc.f90
    devxlib_auxfunc_conjg.f90
    devxlib_auxfunc_vec_upd.f90
    devxlib_auxfunc_mat_upd.f90
    devxlib_auxfunc_addscal.f90
    # Buffers
    devxlib_buffer.f90
    devxlib_pinned.f90
    devxlib_buffers.f90
    # Memset
    devxlib_memset_device.f90
    devxlib_memset.f90
    # Main modules
    devxlib_environment.f90
    devxlib.f90
    # CUDA
    devxlib_cublas.f90
    mod_cublas_core.f90
    mod_cublas.f90
    # ROCm
    devxlib_rocblas.f90
    mod_rocblas.f90
    # Tests
    mod_tester_fbuff.f90
    # Misc
    mod_blas95.f90)
if(DEVXLIB_ENABLE_ACC STREQUAL "CUDAF")
    set(SRC_F_devXlib
        ${SRC_F_devXlib}
        devxlib_memset_host.f90)
endif()
if(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "MKLGPU")
    set(SRC_F_devXlib
        ${SRC_F_devXlib}
        devxlib_mklgpu.f90)
endif()

set(SRC_F_TEST_BUFF test_buffer.f90)
set(SRC_F_TEST_PINN test_pinned.f90)
set(SRC_F_TEST_LINALG test_linalg.f90)
set(SRC_F_TEST_MEMCPY test_memcpy.f90)
set(SRC_F_TEST_MEMCPY_ASYNC test_memcpy_async.f90)
set(SRC_F_TEST_MALLOC test_malloc.f90)
set(SRC_F_TEST_MAPPING test_mapping.f90)

set_source_files_properties(
    ${SRC_F_devXlib}
    ${SRC_F_TEST_BUFF}
    ${SRC_F_TEST_PINN}
    ${SRC_F_TEST_LINALG}
    ${SRC_F_TEST_MEMCPY}
    ${SRC_F_TEST_MEMCPY_ASYNC}
    ${SRC_F_TEST_MALLOC}
    ${SRC_F_TEST_MAPPING}
    PROPERTIES LANGUAGE Fortran)

set_source_files_properties(
    ${SRC_F_devXlib}
    ${SRC_F_TEST_BUFF}
    ${SRC_F_TEST_PINN}
    ${SRC_F_TEST_LINALG}
    ${SRC_F_TEST_MEMCPY}
    ${SRC_F_TEST_MEMCPY_ASYNC}
    ${SRC_F_TEST_MALLOC}
    ${SRC_F_TEST_MAPPING}
    PROPERTIES Fortran_PREPROCESS ON)
set_source_files_properties(
    ${SRC_F_devXlib}
    ${SRC_F_TEST_BUFF}
    ${SRC_F_TEST_PINN}
    ${SRC_F_TEST_LINALG}
    ${SRC_F_TEST_MEMCPY}
    ${SRC_F_TEST_MEMCPY_ASYNC}
    ${SRC_F_TEST_MALLOC}
    ${SRC_F_TEST_MAPPING}
    PROPERTIES CMAKE_Fortran_FORMAT FREE)

add_library(devXlib ${SRC_F_devXlib})
add_executable(test_buffer ${SRC_F_TEST_BUFF})
add_executable(test_pinned ${SRC_F_TEST_PINN})
add_executable(test_linalg ${SRC_F_TEST_LINALG})
add_executable(test_memcpy ${SRC_F_TEST_MEMCPY})
add_executable(test_memcpy_async ${SRC_F_TEST_MEMCPY_ASYNC})
add_executable(test_malloc ${SRC_F_TEST_MALLOC})
add_executable(test_mapping ${SRC_F_TEST_MAPPING})

set(testTargets
    test_buffer
    test_pinned
    test_linalg
    test_memcpy
    test_memcpy_async
    test_malloc
    test_mapping)
set(devXlibTargets
    devXlib
    ${testTargets})

set_target_properties(test_buffer
    PROPERTIES OUTPUT_NAME "test_buffer.x")
set_target_properties(test_pinned
    PROPERTIES OUTPUT_NAME "test_pinned.x")
set_target_properties(test_linalg
    PROPERTIES OUTPUT_NAME "test_linalg.x")
set_target_properties(test_memcpy
    PROPERTIES OUTPUT_NAME "test_memcpy.x")
set_target_properties(test_memcpy_async
    PROPERTIES OUTPUT_NAME "test_memcpy_async.x")
set_target_properties(test_malloc
    PROPERTIES OUTPUT_NAME "test_malloc.x")
set_target_properties(test_mapping
    PROPERTIES OUTPUT_NAME "test_mapping.x")

target_link_libraries(devXlib
    PRIVATE
        LAPACK::LAPACK
        compilerCustomConfig)
foreach(TARGET ${testTargets})
    target_link_libraries(${TARGET}
        PRIVATE
            devXlib
            LAPACK::LAPACK
            compilerCustomConfig)
endforeach(TARGET)

foreach(TARGET ${devXlibTargets})
    target_include_directories(${TARGET} 
        PRIVATE
            "${CMAKE_SOURCE_DIR}/include"
            "${CMAKE_CURRENT_SOURCE_DIR}")

    if(DEVXLIB_ENABLE_ACC STREQUAL "CUDAF")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_CUDAF")
    elseif(DEVXLIB_ENABLE_ACC STREQUAL "OPENACC")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_OPENACC")
        target_link_libraries(${TARGET}
            PRIVATE
                OpenACC::OpenACC_Fortran)
    elseif(DEVXLIB_ENABLE_ACC STREQUAL "OPENMPGPU")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_OPENMP_GPU")
        # Linking for OpenMP host
        target_link_libraries(${TARGET}
        	INTERFACE
        		OpenMP::OpenMP_Fortran
                OpenMP::OpenMP_C)
    endif()

    if(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "CUBLAS")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_CUBLAS")
        target_link_libraries(${TARGET}
            PRIVATE
                "${CUDA_CUDART}"
                "${CUDA_cublas_LIBRARY}")
    elseif(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "MKLGPU")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_MKL_GPU")
        target_include_directories(${TARGET}
            PRIVATE
                ${MKL_H})
    elseif(DEVXLIB_ENABLE_GPU_BLAS STREQUAL "ROCBLAS")
        target_compile_definitions(${TARGET}
            PRIVATE
                "__DXL_ROCBLAS")
        target_link_libraries(${TARGET}
            PRIVATE
                roc::rocblas)
    endif()
endforeach(TARGET)

install(
    TARGETS ${devXlibTargets}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== TESTING/EIG/Makefile ===
include ../../make.inc

########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in REAL and COMPLEX
#     DZIGTST -- Auxiliary test routines used in DOUBLE PRECISION and
#                COMPLEX*16
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       xeigtsts, xeigtstd, xeigtstc, and xeigtstz
#  and are created in the next higher directory level.
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
########################################################################

AEIGTST = \
   alahdg.o \
   alasum.o \
   alasvm.o \
   alareq.o \
   ilaenv.o \
   xerbla.o \
   xlaenv.o \
   chkxer.o

SCIGTST = slafts.o slahd2.o slasum.o slatb9.o sstech.o sstect.o \
   ssvdch.o ssvdct.o ssxt1.o

SEIGTST = schkee.o \
   sbdt01.o sbdt02.o sbdt03.o \
   schkbb.o schkbd.o schkbk.o schkbl.o schkec.o \
   schkgg.o schkgk.o schkgl.o schkhs.o schksb.o schkst.o \
   sckglm.o sckgqr.o sckgsv.o scklse.o \
   sdrges.o sdrgev.o sdrgsx.o sdrgvx.o \
   sdrvbd.o sdrves.o sdrvev.o sdrvgg.o sdrvsg.o \
   sdrvst.o sdrvsx.o sdrvvx.o \
   serrbd.o serrec.o serred.o serrgg.o serrhs.o serrst.o \
   sget02.o sget10.o sget22.o sget23.o sget24.o sget31.o \
   sget32.o sget33.o sget34.o sget35.o sget36.o \
   sget37.o sget38.o sget39.o sget51.o sget52.o sget53.o \
   sget54.o sglmts.o sgqrts.o sgrqts.o sgsvts.o \
   shst01.o slarfy.o slarhs.o slatm4.o slctes.o slctsx.o slsets.o sort01.o \
   sort03.o ssbt21.o ssgt01.o sslect.o sspt21.o sstt21.o \
   sstt22.o ssyt21.o ssyt22.o

CEIGTST = cchkee.o \
   cbdt01.o cbdt02.o cbdt03.o \
   cchkbb.o cchkbd.o cchkbk.o cchkbl.o cchkec.o \
   cchkgg.o cchkgk.o cchkgl.o cchkhb.o cchkhs.o cchkst.o \
   cckglm.o cckgqr.o cckgsv.o ccklse.o \
   cdrges.o cdrgev.o cdrgsx.o cdrgvx.o \
   cdrvbd.o cdrves.o cdrvev.o cdrvgg.o cdrvsg.o \
   cdrvst.o cdrvsx.o cdrvvx.o \
   cerrbd.o cerrec.o cerred.o cerrgg.o cerrhs.o cerrst.o \
   cget02.o cget10.o cget22.o cget23.o cget24.o \
   cget35.o cget36.o cget37.o cget38.o cget51.o cget52.o \
   cget54.o cglmts.o cgqrts.o cgrqts.o cgsvts.o \
   chbt21.o chet21.o chet22.o chpt21.o chst01.o \
   clarfy.o clarhs.o clatm4.o clctes.o clctsx.o clsets.o csbmv.o \
   csgt01.o cslect.o \
   cstt21.o cstt22.o cunt01.o cunt03.o

DZIGTST = dlafts.o dlahd2.o dlasum.o dlatb9.o dstech.o dstect.o \
   dsvdch.o dsvdct.o dsxt1.o

DEIGTST = dchkee.o \
   dbdt01.o dbdt02.o dbdt03.o \
   dchkbb.o dchkbd.o dchkbk.o dchkbl.o dchkec.o \
   dchkgg.o dchkgk.o dchkgl.o dchkhs.o dchksb.o dchkst.o \
   dckglm.o dckgqr.o dckgsv.o dcklse.o \
   ddrges.o ddrgev.o ddrgsx.o ddrgvx.o \
   ddrvbd.o ddrves.o ddrvev.o ddrvgg.o ddrvsg.o \
   ddrvst.o ddrvsx.o ddrvvx.o \
   derrbd.o derrec.o derred.o derrgg.o derrhs.o derrst.o \
   dget02.o dget10.o dget22.o dget23.o dget24.o dget31.o \
   dget32.o dget33.o dget34.o dget35.o dget36.o \
   dget37.o dget38.o dget39.o dget51.o dget52.o dget53.o \
   dget54.o dglmts.o dgqrts.o dgrqts.o dgsvts.o \
   dhst01.o dlarfy.o dlarhs.o dlatm4.o dlctes.o dlctsx.o dlsets.o dort01.o \
   dort03.o dsbt21.o dsgt01.o dslect.o dspt21.o dstt21.o \
   dstt22.o dsyt21.o dsyt22.o

ZEIGTST = zchkee.o \
   zbdt01.o zbdt02.o zbdt03.o \
   zchkbb.o zchkbd.o zchkbk.o zchkbl.o zchkec.o \
   zchkgg.o zchkgk.o zchkgl.o zchkhb.o zchkhs.o zchkst.o \
   zckglm.o zckgqr.o zckgsv.o zcklse.o \
   zdrges.o zdrgev.o zdrgsx.o zdrgvx.o \
   zdrvbd.o zdrves.o zdrvev.o zdrvgg.o zdrvsg.o \
   zdrvst.o zdrvsx.o zdrvvx.o \
   zerrbd.o zerrec.o zerred.o zerrgg.o zerrhs.o zerrst.o \
   zget02.o zget10.o zget22.o zget23.o zget24.o \
   zget35.o zget36.o zget37.o zget38.o zget51.o zget52.o \
   zget54.o zglmts.o zgqrts.o zgrqts.o zgsvts.o \
   zhbt21.o zhet21.o zhet22.o zhpt21.o zhst01.o \
   zlarfy.o zlarhs.o zlatm4.o zlctes.o zlctsx.o zlsets.o zsbmv.o \
   zsgt01.o zslect.o \
   zstt21.o zstt22.o zunt01.o zunt03.o

all: single complex double complex16

single: ../xeigtsts
complex: ../xeigtstc
double: ../xeigtstd
complex16: ../xeigtstz

../xeigtsts: $(SEIGTST) $(SCIGTST) $(AEIGTST) ; \
          $(LOADER) $(LOADOPTS) -o xeigtsts \
          $(SEIGTST) $(SCIGTST) $(AEIGTST) ../../$(TMGLIB) \
	  ../../$(LAPACKLIB) $(BLASLIB) && mv xeigtsts $@

../xeigtstc: $(CEIGTST) $(SCIGTST) $(AEIGTST) ; \
          $(LOADER) $(LOADOPTS) -o xeigtstc \
          $(CEIGTST) $(SCIGTST) $(AEIGTST) ../../$(TMGLIB) \
	  ../../$(LAPACKLIB) $(BLASLIB) && mv xeigtstc $@

../xeigtstd: $(DEIGTST) $(DZIGTST) $(AEIGTST) ; \
          $(LOADER) $(LOADOPTS) -o xeigtstd \
          $(DEIGTST) $(DZIGTST) $(AEIGTST) ../../$(TMGLIB) \
	  ../../$(LAPACKLIB) $(BLASLIB) && mv xeigtstd $@

../xeigtstz: $(ZEIGTST) $(DZIGTST) $(AEIGTST) ; \
          $(LOADER) $(LOADOPTS) -o xeigtstz \
          $(ZEIGTST) $(DZIGTST) $(AEIGTST) ../../$(TMGLIB) \
	  ../../$(LAPACKLIB) $(BLASLIB) && mv xeigtstz $@

$(AEIGTST): $(FRC)
$(SCIGTST): $(FRC)
$(DZIGTST): $(FRC)
$(SEIGTST): $(FRC)
$(CEIGTST): $(FRC)
$(DEIGTST): $(FRC)
$(ZEIGTST): $(FRC)

FRC:
	@FRC=$(FRC)

clean:
	rm -f *.o

schkee.o: schkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
dchkee.o: dchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
cchkee.o: cchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
zchkee.o: zchkee.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@

.f.o : ; $(FORTRAN) $(OPTS) -c $< -o $@

=== TESTING/LIN/Makefile ===
include ../../make.inc

#######################################################################
#  This makefile creates the test programs for the linear equation
#  routines in LAPACK.  The test files are grouped as follows:
#
#       ALINTST -- Auxiliary test routines
#       SLINTST -- Single precision real test routines
#       CLINTST -- Single precision complex test routines
#       SCLNTST -- Single and Complex routines in common
#       DLINTST -- Double precision real test routines
#       ZLINTST -- Double precision complex test routines
#       DZLNTST -- Double and Double Complex routines in common
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       xlintims, xlintimd, xlintimc, and xlintimz
#  and are created in the next higher directory level.
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

ALINTST = \
   aladhd.o alaerh.o alaesm.o alahd.o alareq.o \
   alasum.o alasvm.o chkxer.o icopy.o ilaenv.o xlaenv.o xerbla.o

SCLNTST= slaord.o

DZLNTST= dlaord.o 

SLINTST = schkaa.o \
   schkeq.o schkgb.o schkge.o schkgt.o \
   schklq.o schkpb.o schkpo.o schkps.o schkpp.o \
   schkpt.o schkq3.o schkql.o schkqp.o schkqr.o schkrq.o \
   schksp.o schksy.o schktb.o schktp.o schktr.o \
   schktz.o \
   sdrvgt.o sdrvls.o sdrvpb.o \
   sdrvpp.o sdrvpt.o sdrvsp.o sdrvsy.o \
   serrgt.o serrlq.o serrls.o \
   serrpo.o serrps.o serrql.o serrqp.o serrqr.o \
   serrrq.o serrsy.o serrtr.o serrtz.o serrvx.o \
   sgbt01.o sgbt02.o sgbt05.o sgelqs.o sgeqls.o sgeqrs.o \
   sgerqs.o sget01.o sget02.o \
   sget03.o sget04.o sget06.o sget07.o sgtt01.o sgtt02.o \
   sgtt05.o slaptm.o slarhs.o slatb4.o slatb5.o slattb.o slattp.o \
   slattr.o slavsp.o slavsy.o slqt01.o slqt02.o \
   slqt03.o spbt01.o spbt02.o spbt05.o spot01.o \
   spot02.o spot03.o spot05.o spst01.o sppt01.o \
   sppt02.o sppt03.o sppt05.o sptt01.o sptt02.o \
   sptt05.o sqlt01.o sqlt02.o sqlt03.o sqpt01.o \
   sqrt01.o sqrt02.o sqrt03.o sqrt11.o sqrt12.o \
   sqrt13.o sqrt14.o sqrt15.o sqrt16.o sqrt17.o \
   srqt01.o srqt02.o srqt03.o srzt01.o srzt02.o \
   sspt01.o ssyt01.o \
   stbt02.o stbt03.o stbt05.o stbt06.o stpt01.o \
   stpt02.o stpt03.o stpt05.o stpt06.o strt01.o \
   strt02.o strt03.o strt05.o strt06.o \
   stzt01.o stzt02.o sgennd.o

ifdef USEXBLAS
SLINTST += sdrvgex.o serrgex.o sdrvgbx.o sdrvpox.o sebchvxx.o
else
SLINTST += sdrvge.o serrge.o sdrvgb.o sdrvpo.o
endif

CLINTST = cchkaa.o \
   cchkeq.o cchkgb.o cchkge.o cchkgt.o \
   cchkhe.o cchkhp.o cchklq.o cchkpb.o \
   cchkpo.o cchkps.o cchkpp.o cchkpt.o cchkq3.o cchkql.o cchkqp.o \
   cchkqr.o cchkrq.o cchksp.o cchksy.o cchktb.o \
   cchktp.o cchktr.o cchktz.o \
   cdrvgt.o cdrvhe.o cdrvhp.o \
   cdrvls.o cdrvpb.o cdrvpp.o cdrvpt.o \
   cdrvsp.o cdrvsy.o \
   cerrgt.o cerrhe.o cerrlq.o \
   cerrls.o cerrps.o cerrql.o cerrqp.o \
   cerrqr.o cerrrq.o cerrsy.o cerrtr.o cerrtz.o \
   cerrvx.o \
   cgbt01.o cgbt02.o cgbt05.o cgelqs.o cgeqls.o cgeqrs.o \
   cgerqs.o cget01.o cget02.o \
   cget03.o cget04.o cget07.o cgtt01.o cgtt02.o \
   cgtt05.o chet01.o chpt01.o claipd.o claptm.o clarhs.o clatb4.o clatb5.o \
   clatsp.o clatsy.o clattb.o clattp.o clattr.o \
   clavhe.o clavhp.o clavsp.o clavsy.o clqt01.o \
   clqt02.o clqt03.o cpbt01.o cpbt02.o cpbt05.o \
   cpot01.o cpot02.o cpot03.o cpot05.o cpst01.o \
   cppt01.o cppt02.o cppt03.o cppt05.o cptt01.o \
   cptt02.o cptt05.o cqlt01.o cqlt02.o cqlt03.o \
   cqpt01.o cqrt01.o cqrt02.o cqrt03.o cqrt11.o \
   cqrt12.o cqrt13.o cqrt14.o cqrt15.o cqrt16.o \
   cqrt17.o crqt01.o crqt02.o crqt03.o crzt01.o crzt02.o \
   csbmv.o  cspt01.o \
   cspt02.o cspt03.o csyt01.o csyt02.o csyt03.o \
   ctbt02.o ctbt03.o ctbt05.o ctbt06.o ctpt01.o \
   ctpt02.o ctpt03.o ctpt05.o ctpt06.o ctrt01.o \
   ctrt02.o ctrt03.o ctrt05.o ctrt06.o \
   ctzt01.o ctzt02.o sget06.o cgennd.o

ifdef USEXBLAS
CLINTST += cdrvgex.o cdrvgbx.o cerrgex.o cdrvpox.o cerrpox.o cebchvxx.o
else
CLINTST += cdrvge.o cdrvgb.o cerrge.o cdrvpo.o cerrpo.o
endif

DLINTST = dchkaa.o \
   dchkeq.o dchkgb.o dchkge.o dchkgt.o \
   dchklq.o dchkpb.o dchkpo.o dchkps.o dchkpp.o \
   dchkpt.o dchkq3.o dchkql.o dchkqp.o dchkqr.o dchkrq.o \
   dchksp.o dchksy.o dchktb.o dchktp.o dchktr.o \
   dchktz.o \
   ddrvgt.o ddrvls.o ddrvpb.o \
   ddrvpp.o ddrvpt.o ddrvsp.o ddrvsy.o \
   derrgt.o derrlq.o derrls.o \
   derrps.o derrql.o derrqp.o derrqr.o \
   derrrq.o derrsy.o derrtr.o derrtz.o derrvx.o \
   dgbt01.o dgbt02.o dgbt05.o dgelqs.o dgeqls.o dgeqrs.o \
   dgerqs.o dget01.o dget02.o \
   dget03.o dget04.o dget06.o dget07.o dgtt01.o dgtt02.o \
   dgtt05.o dlaptm.o dlarhs.o dlatb4.o dlatb5.o dlattb.o dlattp.o \
   dlattr.o dlavsp.o dlavsy.o dlqt01.o dlqt02.o \
   dlqt03.o dpbt01.o dpbt02.o dpbt05.o dpot01.o \
   dpot02.o dpot03.o dpot05.o dpst01.o dppt01.o \
   dppt02.o dppt03.o dppt05.o dptt01.o dptt02.o \
   dptt05.o dqlt01.o dqlt02.o dqlt03.o dqpt01.o \
   dqrt01.o dqrt02.o dqrt03.o dqrt11.o dqrt12.o \
   dqrt13.o dqrt14.o dqrt15.o dqrt16.o dqrt17.o \
   drqt01.o drqt02.o drqt03.o drzt01.o drzt02.o \
   dspt01.o dsyt01.o \
   dtbt02.o dtbt03.o dtbt05.o dtbt06.o dtpt01.o \
   dtpt02.o dtpt03.o dtpt05.o dtpt06.o dtrt01.o \
   dtrt02.o dtrt03.o dtrt05.o dtrt06.o \
   dtzt01.o dtzt02.o dgennd.o

ifdef USEXBLAS
DLINTST += ddrvgex.o ddrvgbx.o derrgex.o ddrvpox.o derrpox.o debchvxx.o
else
DLINTST += ddrvge.o ddrvgb.o derrge.o ddrvpo.o derrpo.o
endif

ZLINTST = zchkaa.o \
   zchkeq.o zchkgb.o zchkge.o zchkgt.o \
   zchkhe.o zchkhp.o zchklq.o zchkpb.o \
   zchkpo.o zchkps.o zchkpp.o zchkpt.o zchkq3.o zchkql.o zchkqp.o \
   zchkqr.o zchkrq.o zchksp.o zchksy.o zchktb.o \
   zchktp.o zchktr.o zchktz.o \
   zdrvgt.o zdrvhe.o zdrvhp.o \
   zdrvls.o zdrvpb.o zdrvpp.o zdrvpt.o \
   zdrvsp.o zdrvsy.o \
   zerrgt.o zerrhe.o zerrlq.o \
   zerrls.o zerrps.o zerrql.o zerrqp.o \
   zerrqr.o zerrrq.o zerrsy.o zerrtr.o zerrtz.o \
   zerrvx.o \
   zgbt01.o zgbt02.o zgbt05.o zgelqs.o zgeqls.o zgeqrs.o \
   zgerqs.o zget01.o zget02.o \
   zget03.o zget04.o zget07.o zgtt01.o zgtt02.o \
   zgtt05.o zhet01.o zhpt01.o zlaipd.o zlaptm.o zlarhs.o zlatb4.o zlatb5.o \
   zlatsp.o zlatsy.o zlattb.o zlattp.o zlattr.o \
   zlavhe.o zlavhp.o zlavsp.o zlavsy.o zlqt01.o \
   zlqt02.o zlqt03.o zpbt01.o zpbt02.o zpbt05.o \
   zpot01.o zpot02.o zpot03.o zpot05.o zpst01.o \
   zppt01.o zppt02.o zppt03.o zppt05.o zptt01.o \
   zptt02.o zptt05.o zqlt01.o zqlt02.o zqlt03.o \
   zqpt01.o zqrt01.o zqrt02.o zqrt03.o zqrt11.o \
   zqrt12.o zqrt13.o zqrt14.o zqrt15.o zqrt16.o \
   zqrt17.o zrqt01.o zrqt02.o zrqt03.o zrzt01.o zrzt02.o \
   zsbmv.o  zspt01.o \
   zspt02.o zspt03.o zsyt01.o zsyt02.o zsyt03.o \
   ztbt02.o ztbt03.o ztbt05.o ztbt06.o ztpt01.o \
   ztpt02.o ztpt03.o ztpt05.o ztpt06.o ztrt01.o \
   ztrt02.o ztrt03.o ztrt05.o ztrt06.o \
   ztzt01.o ztzt02.o dget06.o zgennd.o

ifdef USEXBLAS
ZLINTST += zdrvgex.o zdrvgbx.o zerrgex.o zdrvpox.o zerrpox.o zebchvxx.o
else
ZLINTST += zdrvge.o zdrvgb.o zerrge.o zdrvpo.o zerrpo.o
endif

DSLINTST = dchkab.o \
	ddrvab.o ddrvac.o derrab.o derrac.o dget08.o          \
	alaerh.o alahd.o  aladhd.o alareq.o \
	chkxer.o dlarhs.o dlatb4.o xerbla.o \
	dget02.o dpot06.o

ZCLINTST = zchkab.o \
	zdrvab.o zdrvac.o zerrab.o zerrac.o zget08.o          \
	alaerh.o alahd.o  aladhd.o alareq.o \
	chkxer.o zget02.o zlarhs.o zlatb4.o \
	zsbmv.o  xerbla.o zpot06.o zlaipd.o

SLINTSTRFP = schkrfp.o sdrvrfp.o sdrvrf1.o sdrvrf2.o sdrvrf3.o sdrvrf4.o serrrfp.o \
	slatb4.o slarhs.o sget04.o spot01.o spot03.o spot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

DLINTSTRFP = dchkrfp.o ddrvrfp.o ddrvrf1.o ddrvrf2.o ddrvrf3.o ddrvrf4.o derrrfp.o \
	dlatb4.o dlarhs.o dget04.o dpot01.o dpot03.o dpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

CLINTSTRFP = cchkrfp.o cdrvrfp.o cdrvrf1.o cdrvrf2.o cdrvrf3.o cdrvrf4.o cerrrfp.o \
	claipd.o clatb4.o clarhs.o csbmv.o cget04.o cpot01.o cpot03.o cpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

ZLINTSTRFP = zchkrfp.o zdrvrfp.o zdrvrf1.o zdrvrf2.o zdrvrf3.o zdrvrf4.o zerrrfp.o \
	zlatb4.o zlaipd.o zlarhs.o zsbmv.o zget04.o zpot01.o zpot03.o zpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

all:  single double complex complex16 proto-single proto-double proto-complex proto-complex16

single: ../xlintsts
double: ../xlintstd
complex: ../xlintstc
complex16: ../xlintstz 

proto-single: ../xlintstrfs
proto-double: ../xlintstds ../xlintstrfd
proto-complex: ../xlintstrfc
proto-complex16: ../xlintstzc ../xlintstrfz

../xlintsts : $(ALINTST) $(SLINTST) $(SCLNTST)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(SCLNTST) $(SLINTST) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o xlintsts && mv xlintsts $@

../xlintstc : $(ALINTST) $(CLINTST) $(SCLNTST)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(SCLNTST) $(CLINTST) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o xlintstc && mv xlintstc $@
 
../xlintstd : $(ALINTST) $(DLINTST) $(DZLNTST)
	$(LOADER) $(LOADOPTS) $^ \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(XBLASLIB) $(BLASLIB) -o xlintstd && mv xlintstd $@
 
../xlintstz : $(ALINTST) $(ZLINTST) $(DZLNTST)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(DZLNTST) $(ZLINTST) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o xlintstz && mv xlintstz $@
 
../xlintstds : $(DSLINTST)
	$(LOADER) $(LOADOPTS)  $(DSLINTST) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstds && mv xlintstds $@
 
../xlintstzc : $(ZCLINTST)
	$(LOADER) $(LOADOPTS)  $(ZCLINTST) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstzc && mv xlintstzc $@
 
../xlintstrfs : $(SLINTSTRFP)
	$(LOADER) $(LOADOPTS)  $(SLINTSTRFP) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstrfs && mv xlintstrfs $@
 
../xlintstrfd : $(DLINTSTRFP)
	$(LOADER) $(LOADOPTS)  $(DLINTSTRFP) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstrfd && mv xlintstrfd $@
 
../xlintstrfc : $(CLINTSTRFP)
	$(LOADER) $(LOADOPTS)  $(CLINTSTRFP) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstrfc && mv xlintstrfc $@
 
../xlintstrfz : $(ZLINTSTRFP)
	$(LOADER) $(LOADOPTS)  $(ZLINTSTRFP) \
        ../../$(TMGLIB) ../../$(LAPACKLIB) $(BLASLIB) -o xlintstrfz && mv xlintstrfz $@
 
$(ALINTST): $(FRC)
$(SCLNTST): $(FRC)
$(DZLNTST): $(FRC)
$(SLINTST): $(FRC)
$(CLINTST): $(FRC)
$(DLINTST): $(FRC)
$(ZLINTST): $(FRC)

FRC:
	@FRC=$(FRC)
 
clean:
	rm -f *.o

schkaa.o: schkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
dchkaa.o: dchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
cchkaa.o: cchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
zchkaa.o: zchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
 
.f.o: 
	$(FORTRAN) $(OPTS) -c $< -o $@

=== extlibs/blas/Makefile ===
#
#===============================
# WanT package
#===============================
#
-include ../../make.inc

LIBNAME=libblas.a
PACKAGE=BLAS
TARBALL=../archive/blas-1.tar.gz

#
# redefinitions
#
INSTALL_DIR=$(TOPDIR)/extlibs/blas/tmp
#AUXFLAGS= --prefix=$(INSTALL_DIR)

#
# MAIN target
#
all: package-ready-stamp

uncompress-stamp:
	gunzip < $(TARBALL) | ../../config/missing --run tar xf -
	test -d $(INSTALL_DIR) || mkdir $(INSTALL_DIR)
	touch uncompress-stamp

configure-stamp: uncompress-stamp
	if test -d $(PACKAGE) ; then ( cd $(PACKAGE);  \
		if test -e ./make.inc ; then rm ./make.inc ; fi ; \
	        if test -e ../../../install/make_blas.inc ; then \
	           cp ../../../install/make_blas.inc ./make.inc ; \
	        fi ) ; \
	fi
	touch configure-stamp
#	if test ./install ; then ( cd ./install ;  \
#	        ./configure_blas $(AUXFLAGS)  \
#	        FC=$(F90) \
#	        F77=$(F77) \
#	        FFLAGS="$(FFLAGS)" \
#	        FCFLAGS="$(F90FLAGS)" \
#	        INSTALL_DIR="$(INSTALL_DIR)" ); \
#	fi
	
package-ready-stamp: uncompress-stamp configure-stamp
	if test -d $(PACKAGE) ; then \
	( cd $(PACKAGE);  $(MAKE) ) ; fi
	#
	if test -d ./lib      ; then rm -rf ./lib      ; fi
	mkdir ./lib ;
	mv $(PACKAGE)/*.a ./lib ;
	#
	touch package-ready-stamp

#
# cleaning
#
clean:
	if test -d $(PACKAGE) ; then ( cd $(PACKAGE);  $(MAKE) clean ) ; fi
	- rm -rf ./lib package-ready-stamp configure-stamp

distclean: clean
	if test -d $(PACKAGE) ; then ( rm -rf $(PACKAGE) ) ; fi 
	- rm uncompress-stamp package-ready-stamp
	- rm ../install/make_blas.inc
	- rm -rf $(INSTALL_DIR)

=== debian/changelog ===
devicexlib (0.8.5-2) unstable; urgency=medium

  * debian/patches/fix_ppc64le_configure.patch: New patch, fixes configure for
    ppc64le (Closes: #1077608).
  * debian/control (Build-Depends): Added architecture-is-64-bit (Closes:
    #1077607).
  * debian/rules (override_dh_auto_configure): Removed.
  * debian/rules (override_dh_auto_build): Run dh_auto_build rather $(MAKE)
    directly.

 -- Michael Banck <mbanck@debian.org>  Sun, 16 Mar 2025 15:46:28 +0100

devicexlib (0.8.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules (override_dh_auto_configure): Output config.log if configure
    fails.

 -- Michael Banck <mbanck@debian.org>  Sat, 18 Jan 2025 10:48:41 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>> 12~),
+Build-Depends: architecture-is-64-bit,
+               debhelper (>> 12~),
                gfortran,
                libblas-dev,
                liblapack-dev

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/devicexlib.*\.tar\.gz/devicexlib-$1\.tar\.gz/g \
  https://gitlab.com/max-centre/components/devicexlib/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*
